<?php 

$prefix = 'pricet_';

$awesome_price_table = array(
	'id' => 'awesome-meta-box',
	'title' => 'Details',
	'page' => 'price_table',
	'context' => 'normal',
	'priority' => 'high',
	'fields' => array(
		array(
			'name' => 'Currency',
			'id' => $prefix . 'curency',
			'type' => 'text',
			'std' => ''
		),		
		array(
			'name' => 'Price',
			'id' => $prefix . 'price',
			'type' => 'text',
			'std' => ''
		),	
		array(
			'name' => 'Time Range',
			'id' => $prefix . 'trange',
			'type' => 'text',
			'std' => ''
		),	
		array(
			'name' => 'Description',
			'desc' => 'Type description here.',
			'id' => $prefix . 'desc',
			'type' => 'textarea',
			'std' => ''
		),		
		array(
			'name' => 'Button URL',
			'id' => $prefix . 'surl',
			'type' => 'text',
			'std' => 'http://'
		),
		array(
			'name' => 'Button Text',
			'id' => $prefix . 'slink',
			'type' => 'text',
			'std' => ''
		),
		array(
			'name' => 'Highlight',
			'id' => $prefix . 'active',
			'type' => 'checkbox',
		),		
		array(
			'name' => 'Detail 1',
			'id' => $prefix . 'detail1',
			'type' => 'text',
			'std' => ''
		),			
		array(
			'name' => 'Detail 2',
			'id' => $prefix . 'detail2',
			'type' => 'text',
			'std' => ''
		),			
		array(
			'name' => 'Detail 3',
			'id' => $prefix . 'detail3',
			'type' => 'text',
			'std' => ''
		),			
		array(
			'name' => 'Detail 4',
			'id' => $prefix . 'detail4',
			'type' => 'text',
			'std' => ''
		),			
		array(
			'name' => 'Detail 5',
			'id' => $prefix . 'detail5',
			'type' => 'text',
			'std' => ''
		),	
		array(
			'name' => 'Detail 6',
			'id' => $prefix . 'detail6',
			'type' => 'text',
			'std' => ''
		)
	)
);

add_action('admin_menu', 'pricetable_add_box');

// Add meta box
function pricetable_add_box() {
	global $awesome_price_table;
	
	add_meta_box($awesome_price_table['id'], $awesome_price_table['title'], 'pricetable_show_box', $awesome_price_table['page'], $awesome_price_table['context'], $awesome_price_table['priority']);
}

// Callback function to show fields in meta box
function pricetable_show_box() {
	global $awesome_price_table, $post;
	
	// Use nonce for verification
	echo '<input type="hidden" name="mytheme_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';
	
	echo '<table class="form-table">';

	foreach ($awesome_price_table['fields'] as $field) {
		// get current post meta data
		$meta = get_post_meta($post->ID, $field['id'], true);
		
		echo '<tr>',
				'<th style="width:20%"><label for="', $field['id'], '">', $field['name'], '</label></th>',
				'<td>';
		switch ($field['type']) {
			case 'text':
				echo '<input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:97%" />',
					'<br />', $field['desc'];
				break;
			case 'textarea':
				echo '<textarea name="', $field['id'], '" id="', $field['id'], '" cols="60" rows="4" style="width:97%">', $meta ? $meta : $field['std'], '</textarea>',
					'<br />', $field['desc'];
				break;
			case 'select':
				echo '<select name="', $field['id'], '" id="', $field['id'], '">';
				foreach ($field['options'] as $option) {
					echo '<option', $meta == $option ? ' selected="selected"' : '', '>', $option, '</option>';
				}
				echo '</select>';
				break;
			case 'radio':
				foreach ($field['options'] as $option) {
					echo '<input type="radio" name="', $field['id'], '" value="', $option['value'], '"', $meta == $option['value'] ? ' checked="checked"' : '', ' />', $option['name'];
				}
				break;
			case 'checkbox':
				echo '<input type="checkbox" name="', $field['id'], '" id="', $field['id'], '"', $meta ? ' checked="checked"' : '', ' />';
				break;
		}
		echo 	'<td>',
			'</tr>';
	}
	
	echo '</table>';
}

add_action('save_post', 'pricetable_save_data');

// Save data from meta box
function pricetable_save_data($post_id) {
	global $awesome_price_table;
	
	// verify nonce
	if (!wp_verify_nonce( isset($_POST['mytheme_meta_box_nonce']), basename(__FILE__))) {
		return $post_id;
	}

	// check autosave
	if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
		return $post_id;
	}

	// check permissions
	if ('page' == $_POST['post_type']) {
		if (!current_user_can('edit_page', $post_id)) {
			return $post_id;
		}
	} elseif (!current_user_can('edit_post', $post_id)) {
		return $post_id;
	}
	
	foreach ($awesome_price_table['fields'] as $field) {
		$old = get_post_meta($post_id, $field['id'], true);
		$new = $_POST[$field['id']];
		
		if ($new && $new != $old) {
			update_post_meta($post_id, $field['id'], $new);
		} elseif ('' == $new && $old) {
			delete_post_meta($post_id, $field['id'], $old);
		}
	}
}

?>